/* ====================================================================
 * FTD4Linux Software License, Version 1.0
 *
 * Copyright (c) 2000-2004 The FTD4Linux Development Team.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        FTD4Linux Development Team (http://www.ftd4linux.2y.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "FTD" and "FTD4Linux" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact alguno@ftd4linux.2y.net.
 *
 * 5. Products derived from this software may not be called "FTD4Linux",
 *    nor may "FTD4Linux" appear in their name, without prior written
 *    permission of the FTD4Linux Development Team.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE FTD4LINUX DEVELOPMENT TEAM OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _FTD_EVENTINFO_CACHE_H_
#define _FTD_EVENTINFO_CACHE_H_

typedef struct FTDEventInfoCache FTDEventInfoCache;

#define FTD_EVENT_INFO_CACHE_TYPE_OBJECT       (ftd_event_info_cache_get_type ())
#define FTD_EVENT_INFO_CACHE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FTD_EVENT_INFO_CACHE_TYPE_OBJECT, FTDEventInfoCache))
#define FTD_EVENT_INFO_CACHE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FTD_EVENT_INFO_CACHE_TYPE_OBJECT, FTDEventInfoCacheClass))
#define FTD_IS_EVENT_INFO_CACHE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FTD_EVENT_INFO_CACHE_TYPE_OBJECT))
#define FTD_IS_EVENT_INFO_CACHE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FTD_EVENT_INFO_CACHE_TYPE_OBJECT))
#define FTD_EVENT_INFO_CACHE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FTD_EVENT_INFO_CACHE_TYPE_OBJECT, FTDEventInfoCacheClass))

FTDEventInfoCache   *ftd_event_info_cache_new(void);
void                 ftd_event_info_cache_destroy(FTDEventInfoCache *obj);

FtdEvent            *ftd_event_info_cache_lookup(FTDEventInfoCache *obj, int postId);
void                 ftd_event_info_cache_append_eventinfo(FTDEventInfoCache *obj, const FtdEvent *event);

#endif /* _FTD_EVENTINFO_CACHE_H_ */
