/* ====================================================================
 * FTD4Linux Software License, Version 1.0
 *
 * Copyright (c) 2000-2004 The FTD4Linux Development Team.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        FTD4Linux Development Team (http://www.ftd4linux.2y.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "FTD" and "FTD4Linux" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact alguno@ftd4linux.2y.net.
 *
 * 5. Products derived from this software may not be called "FTD4Linux",
 *    nor may "FTD4Linux" appear in their name, without prior written
 *    permission of the FTD4Linux Development Team.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE FTD4LINUX DEVELOPMENT TEAM OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _FTD_GUI_CENTER_H_
#define _FTD_GUI_CENTER_H_

typedef struct _ftd_gui_center_eventlist    FtdGuiCenterEventList;
typedef struct _ftd_gui_center_eventinfo    FtdGuiCenterEventInfo;
typedef struct _ftd_gui_center_watchlist    FtdGuiCenterWatchlist;
typedef struct _ftd_gui_center_watcher      FtdGuiCenterWatcher;
typedef struct _ftd_gui_center_myftd        FtdGuiCenterMyFTD;
typedef struct _ftd_gui_center_vrienden     FtdGuiCenterVrienden;
typedef struct _ftd_gui_center_irc          FtdGuiCenterIRC;

#include "ftd_gui_center_eventlist.h"
#include "ftd_gui_center_eventinfo.h"
#include "ftd_gui_center_watchlist.h"
#include "ftd_gui_center_watcher.h"
#include "ftd_gui_center_myftd.h"
#include "ftd_gui_center_vrienden.h"
#include "ftd_gui_center_irc.h"

struct _ftd_gui_center {
    FtdGuiCenterEventList   *eventlist;
    FtdGuiCenterEventInfo   *eventinfo[MAX_EVENT_INFO];
    FtdGuiCenterWatchlist   *watchlist;
    FtdGuiCenterWatcher     *watcher;
    FtdGuiCenterMyFTD       *myftd;
    FtdGuiCenterVrienden    *vrienden;
    FtdGuiCenterIRC         *irc;
    GtkWidget               *widget; /* notebook */
};

void         ftd_gui_center_new(void);
void         ftd_gui_center_switch_page(GtkNotebook *, GtkNotebookPage *, guint, gpointer);
void         ftd_gui_center_launch_browser(char *);

#endif /* _FTD_GUI_CENTER_H_ */
