/* ====================================================================
 * FTD4Linux Software License, Version 1.0
 *
 * Copyright (c) 2000-2004 The FTD4Linux Development Team.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        FTD4Linux Development Team (http://www.ftd4linux.2y.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "FTD" and "FTD4Linux" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact alguno@ftd4linux.2y.net.
 *
 * 5. Products derived from this software may not be called "FTD4Linux",
 *    nor may "FTD4Linux" appear in their name, without prior written
 *    permission of the FTD4Linux Development Team.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE FTD4LINUX DEVELOPMENT TEAM OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _FTD_GUI_TOOLBAR_H_
#define _FTD_GUI_TOOLBAR_H_

struct _ftd_gui_toolbar {
    GtkWidget           *widget;
    GtkToolItem         *itemUpdaten;
    GtkWidget           *imgUpdaten;
    GtkToolItem         *itemConfig;
    GtkWidget           *imgConfig;
    GtkToolItem         *itemToevoegen;
    GtkWidget           *imgToevoegen;
    GtkToolItem         *itemMail;
    GtkWidget           *imgMail;
    GtkToolItem         *itemNieuw;
    GtkWidget           *imgNieuw;
    GtkToolItem         *itemRefresh;
    GtkWidget           *imgRefresh;
    GtkToolItem         *itemDayselector;
    GtkWidget           *imgDayselector;
    GtkToolItem         *itemVrienden;
    GtkWidget           *imgVrienden;
    GtkToolItem         *itemWatchlist;
    GtkWidget           *imgWatchlist;
    GtkToolItem         *itemWatcher;
    GtkWidget           *imgWatcher;
    GtkToolItem         *itemMyFTD;
    GtkWidget           *imgMyFTD;
    GtkToolItem         *itemHulp;
    GtkWidget           *imgHulp;
    GtkToolItem         *itemModje;
    GtkWidget           *imgModje;
};

/* functie prototypes */
void         ftd_gui_toolbar_new(void);
gboolean     ftd_gui_toolbar_adjust_watchlist(gpointer);
gboolean     ftd_gui_toolbar_adjust_watcher(gpointer data);

#endif /* _FTD_GUI_TOOLBAR_H_ */
