/* ====================================================================
 * FTD4Linux Software License, Version 1.0
 *
 * Copyright (c) 2000-2004 The FTD4Linux Development Team.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        FTD4Linux Development Team (http://www.ftd4linux.2y.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "FTD" and "FTD4Linux" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact alguno@ftd4linux.2y.net.
 *
 * 5. Products derived from this software may not be called "FTD4Linux",
 *    nor may "FTD4Linux" appear in their name, without prior written
 *    permission of the FTD4Linux Development Team.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE FTD4LINUX DEVELOPMENT TEAM OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "ftd_gui_main.h"
#include "ftd_gui_search.h"
#include "ftd_gui_group_view.h"
#include "ftd_gui_categories.h"
#include "ftd_gui_status_filter.h"

void
ftd_gui_sidebar_new(void)
{
    FtdGuiSidebar *bar = (FtdGuiSidebar *) g_malloc0(sizeof(FtdGuiSidebar));

    g_assert(gui);
    g_assert(gui->worksheet);
    gui->worksheet->sidebar = bar;

    bar->widget = gtk_vbox_new(FALSE, 0);
    gtk_widget_show(bar->widget);
    gtk_paned_pack1(GTK_PANED(gui->worksheet->widget), gui->worksheet->sidebar->widget, FALSE, FALSE);

    ftd_gui_search_new();
    gtk_box_pack_start(GTK_BOX(bar->widget), bar->search->widget, FALSE, FALSE, 0);

    ftd_gui_categories_new();
    gtk_box_pack_start(GTK_BOX(bar->widget), bar->categories->widget, TRUE, TRUE, 0);

    if (ftd_config_get()->toonGUIGroupFilter) {
        ftd_gui_group_view_new();
        gtk_box_pack_start(GTK_BOX(bar->widget), bar->group_view->widget, TRUE, TRUE, 0);
    }

#if 0
    ftd_gui_status_filter_new();
    gtk_box_pack_start(GTK_BOX(bar->widget), bar->status_filter->widget, FALSE, TRUE, 0);
#endif
}
